unit Base64;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdCoder00E, IdCoderUUE, IdBaseComponent, IdCoder,
  IdCoder3to4, IdCoderMIME;

type
  TBase64Form = class(TForm)
    WorminationMode: TComboBox;
    LabelT:     TLabel;
    Label1:     TLabel;
    Label2:     TLabel;
    Label3:     TLabel;
    LabelCB1:   TLabel;
    LabelCB2:   TLabel;
    LabelCB3:   TLabel;
    LabelL1:    TLabel;
    LabelL2:    TLabel;
    LabelL3:    TLabel;
    Base64Exit: TButton;
    Variant1:   TMemo;
    Variant2:   TMemo;
    Variant3:   TMemo;
    procedure WorminationModeChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Base64ExitClick(Sender: TObject);
    procedure Variant1Enter(Sender: TObject);
    procedure Variant1Exit(Sender: TObject);
    procedure Variant2Enter(Sender: TObject);
    procedure Variant2Exit(Sender: TObject);
    procedure Variant3Enter(Sender: TObject);
    procedure Variant3Exit(Sender: TObject);
  private
    { Private declarations }
    function SnortSignature(content: string; variant: integer): string;
    function Encode64(S: string): string;
  public
    { Public declarations }
    input: string;
  end;

var
  Base64Form: TBase64Form;

implementation

uses main;

{$R *.dfm}


procedure TBase64Form.FormShow(Sender: TObject);
begin
  Application.MainForm.Enabled := False;
  WorminationModeChange(Sender);
  Variant1.SetFocus;
end;

procedure TBase64Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.MainForm.Enabled := True;
end;

procedure TBase64Form.Base64ExitClick(Sender: TObject);
begin
  Base64Form.Close;
end;

procedure TBase64Form.Variant1Enter(Sender: TObject);
begin
  Variant1.SelectAll;
  Variant1.CopyToClipboard;
  LabelCB1.Visible   := True;
  Variant1.SelLength := 0;
end;

procedure TBase64Form.Variant1Exit(Sender: TObject);
begin
  LabelCB1.Visible := False;
end;

procedure TBase64Form.Variant2Enter(Sender: TObject);
begin
  Variant2.SelectAll;
  Variant2.CopyToClipboard;
  LabelCB2.Visible   := True;
  Variant2.SelLength := 0;
end;

procedure TBase64Form.Variant2Exit(Sender: TObject);
begin
  LabelCB2.Visible := False;
end;

procedure TBase64Form.Variant3Enter(Sender: TObject);
begin
  Variant3.SelectAll;
  Variant3.CopyToClipboard;
  LabelCB3.Visible   := True;
  Variant3.SelLength := 0;
end;

procedure TBase64Form.Variant3Exit(Sender: TObject);
begin
  LabelCB3.Visible := False;
end;

procedure TBase64Form.WorminationModeChange(Sender: TObject);
var
  temp, V1, V2, V3: string;
  I: integer;
begin
  temp := input;

  // encode `em
  V1 := Encode64(temp);
  V2 := Encode64('E' + temp);
  V3 := Encode64('CL' + temp);
  // input length
  I  := length(temp);
  // this is so much simpler in C...
  SetLength(V1, (I * 8 div 6));
  SetLength(V2, ((I + 1) * 8 - 12) div 6 + 2);
  SetLength(V3, ((I + 2) * 8 - 18) div 6 + 3);
  Delete(V2, 1, 2);
  Delete(V3, 1, 3);

  if WorminationMode.ItemIndex = 0 then
  begin
    Variant1.Text := V1;
    Variant2.Text := V2;
    Variant3.Text := V3;
  end
  else
  begin
    Randomize();
    Variant1.Text := SnortSignature(V1, 1);
    Variant2.Text := SnortSignature(V2, 2);
    Variant3.Text := SnortSignature(V3, 3);
  end;
  LabelL1.Caption := 'Length: ' + IntToStr(Length(V1));
  LabelL2.Caption := 'Length: ' + IntToStr(Length(V2));
  LabelL3.Caption := 'Length: ' + IntToStr(Length(V3));
end;

function TBase64Form.SnortSignature(content: string; variant: integer): string;
var
  msg: string;
  sid: cardinal;
begin
  msg    := 'Worminator ' + ExtractFileName(MainForm.HexDump.FileName) + ' Attachment';
  sid    := 1337000 + MainForm.HexDump.SelStart + random(1333370);
  Result := 'alert tcp $EXTERNAL_NET any -> $HOME_NET 25 (msg:"' +
    msg + ' Inbound (' + IntToStr(variant) + ')"; flow:established,to_server; ' +
    'content:"' + content + '"; nocase; classtype:misc-activity; sid:' +
    IntToStr(sid + cardinal(variant)) + '; rev:1;)'#13#10 +
    'alert tcp $HOME_NET any -> $EXTERNAL_NET 25 (msg:"' + msg +
    ' Outbound (' + IntToStr(variant) + ')"; flow:established,to_server; ' +
    'content:"' + content + '"; nocase; classtype:misc-activity; sid:' +
    IntToStr(sid + cardinal(variant) + 1) + '; rev:1;)';
end;

function TBase64Form.Encode64(S: string): string;
const
  Base64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
var
  I, A, B, X: integer;
begin
  Result := '';
  A      := 0;
  B      := 0;
  for I := 1 to Length(S) do
  begin
    X := Ord(S[I]);
    B := B * 256 + X;
    A := A + 8;
    while A >= 6 do
    begin
      A      := A - 6;
      X      := B div (1 shl A);
      B      := B mod (1 shl A);
      Result := Result + Base64[X + 1];
    end;
  end;
  if A > 0 then
  begin
    X      := B shl (6 - A);
    Result := Result + Base64[X + 1];
  end;
end;



end.
